//#include<iostream>
#include<cstdio>
#include<cctype>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<list>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<utility>
#include<sstream>
#include<cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<=(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define ALL(X) (X).begin(),(X).end()
#define PB push_back
#define MP make_pair
#define X first
#define Y second
#define INFTY 100000000
#define VAR(V,init) __typeof(init) V=(init)
#define FORE(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)

typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long ll;
typedef vector<string> VS;

ll nwd(ll a,ll b) { return !b?a:nwd(b,a%b); }
template <class T> inline T sqr(const T&a) { return a*a; }

#define MAXN 100000
#define MAXM 100000
#define MAXK 100000

vector<int> graf[MAXN], gs[MAXN];

set<PII> wynik;

int czas[MAXN], scc[MAXN];
int akt_czas;

void dfs(int nr, int par)
{
    czas[nr] = -1;
    FORE(it, graf[nr])
    {
        if(*it != par && czas[*it] <= 0)
            gs[*it].PB(nr);
        if(czas[*it] == 0)
            dfs(*it, nr);
    }
    czas[nr] = akt_czas ++;
}

void mark_scc(int nr, int scc_nr)
{
    scc[nr] = scc_nr;
    FORE(it, gs[nr])
    {
        if(scc[*it] == -1)
            mark_scc(*it, scc_nr);
    }
}

vector<int> w_in[MAXN];
vector<int> w_out[MAXN];
int odw[MAXN];

set<PII>* merge(set<PII>* a, set<PII>* b)
{
    if(a->size() > b->size())
        swap(a,b);
    FORE(it, (*a))
        b->insert(*it);
    delete a;
    return b;
}

void remove_intersection(set<PII>* in, set<PII>* out)
{
    if(in->size() > out->size())
        swap(in, out);

    set<PII>::iterator it = in->begin(), jt;
    while(it!=in->end())
    {
        jt = out->find(*it);
        if(jt == out->end())
            it ++;
        else
        {
            out->erase(jt);
            in->erase(it++);
        }
    }
}

set<PII> dwyn;

pair<int, set<PII>*> rek(int w, vector<int>* drzewo)
{
    odw[w] = 1;
    set<PII> *in, *out;
    in = new set<PII>;
    out = new set<PII>;
    FORE(it, drzewo[w])
    {
        if(odw[*it]) continue;
        pair<int, set<PII>*> wyn = rek(*it, drzewo);
        if(wyn.X < 0)
            return wyn;
//        printf("rek %d -> %d\n", *it, wyn.X);
  //      FORE(jt,(* wyn.Y))
    //        printf("(%d %d)  ", jt->X, jt->Y);
      //  printf("\n");
        if(wyn.X == 1)
        {
            dwyn.insert(MP(*it, w));
            in = merge(in, wyn.Y);
        }
        else
        {
            dwyn.insert(MP(w, *it));
            out = merge(out, wyn.Y);
        }
    }
   /* printf("zbr\n");
    FORE(it, (*in))
        printf("%d %d   ", it->X, it->Y);
    printf("\n");
    FORE(it, (*out))
        printf("%d %d   ", it->X, it->Y);
    printf("\n");*/
    remove_intersection(in, out);

    
    set<PII>::iterator el;
    FORE(it, w_in[w])
    {
        el = in->find(MP(w, *it));
        if(el == in->end())
            out->insert(MP(w, *it));
        else
            in->erase(el);
    }
    FORE(it, w_out[w])
    {
        el = out->find(MP(*it, w));
        if(el == out->end())
            in->insert(MP(*it, w));
        else
            out->erase(el);
    }
    //printf("EMP %d %d\n", in->empty(), out->empty());
    if(!in->empty() && !out->empty())
       return MP(-1, out);
    if(out->empty())
    {
        delete out;
        return MP(1, in);
    }
    else
    {
        delete in;
        return MP(2, out);
    }
}

int rozwiaz_drzewo(int n, vector<int>* drzewo, vector<PII>& wymagania)
{
    sort(ALL(wymagania));
    wymagania.erase(unique(ALL(wymagania)), wymagania.end());
    FORE(it, wymagania)
    {
        w_in[it->Y].PB(it->X);
        w_out[it->X].PB(it->Y);
    }
    REP(i, n)
        if(!odw[i])
        {
            pair<int, set<PII>*> wyn = rek(i, drzewo);
            if(wyn.X < 0 || !wyn.Y->empty())
                return 0;
        }
    return 1;
}

int main()
{
    int n, m, k;
    scanf("%d%d%d", &n, &m, &k);
    vector<PII> kraw;
    vector<PII> wymagania;
    vector<int> drzewo[MAXN];

    REP(i, m)
    {
        int a, b;
        scanf("%d%d",&a, &b);
        a --; b --;
        kraw.PB(MP(a,b));
        graf[a].PB(b);
        graf[b].PB(a);
    }
    REP(i, k)
    {
        int a, b;
        scanf("%d%d",&a, &b);
        a --; b --;
        wymagania.PB(MP(a,b));
    }
    akt_czas = 1;
    REP(i, n)
    {
        if(czas[i] == 0)
            dfs(i, -1);
        scc[i] = -1;
    }
    
    vector<PII> czas_w;
    REP(i, n) czas_w.PB(MP(czas[i], i));
    sort(ALL(czas_w), greater<PII>());
    
    int scc_count = 0;
    REP(i, n)
    {
        if(scc[czas_w[i].Y] == -1)
            mark_scc(czas_w[i].Y, scc_count++);
    }

    vector<PII> wym_drzewo;
    FORE(it, kraw)
    {
        int a = scc[it->X];
        int b = scc[it->Y];
        if(a == b)
            continue;

        drzewo[a].PB(b);
        drzewo[b].PB(a);
    //    printf("drz %d %d\n", a, b);
    }
    FORE(it, wymagania)
    {
        if(scc[it->X] != scc[it->Y])
            wym_drzewo.PB(MP(scc[it->X], scc[it->Y]));
    }

    if(rozwiaz_drzewo(scc_count, drzewo, wym_drzewo) == 0)
    {
        printf("NO\n");
        return 0;
    }

    set<PII> wynik;
//    FORE(it, dwyn)
  //      printf("krd %d %d   \n", it->X, it->Y);
    REP(i, n)
        FORE(it, gs[i])
        {
//            printf("kgs %d %d  %d\n", scc[i], scc[*it], dwyn.count(MP(scc[i], scc[*it])));
            if(scc[i] == scc[*it])
                wynik.insert(MP(i, *it));
            else if(dwyn.count(MP(scc[i], scc[*it])))
                wynik.insert(MP(i, *it));
            else
                wynik.insert(MP(*it, i));
        }
    printf("YES\n");
    FORE(it, kraw)
    {
        if(wynik.count(MP(it->X, it->Y)))
            printf("%d %d\n", it->X+1, it->Y+1);
        else
            printf("%d %d\n", it->Y+1, it->X+1);
    }
    return 0;
}
