#include <iostream>
#include <vector>
#include <bitset>
#include <cstring>
#include <map>
#include <stack>
#include <cstdio>
#define VAR(i,a) __typeof(a) i = (a)
#define REP(i,n) for(int i=0, _n=(n); i<_n; ++i)
#define FORD(i, a, b) for(int i=(a); i>=(b); i--)
#define FORE(i,a) for(VAR(i,(a).begin()); i!=(a).end(); ++i)
#define SIZE(a) ((int)(a).size())
#define PII pair<int, int>
#define VI vector<int>
#define PB push_back
using namespace std;

#include "weryfikator.h"

#define MAXN 50000
#define MAXM 200000
#define MAXK 200000

void my_error(const char* msg, int line=0, int pos=0)
{
    fprintf(stdout, "WRONG\n%s\n", msg);
    exit(1);
}

struct Edge{
  int v; /*wierzcholek docelowy*/
};

struct Vertex{
  vector<Edge> kr;
  int t; /*dane pomocnicze*/ 
  int s; /*dane pomocnicze*/
};

struct Graf{
  vector<Vertex> g;
  Graf(int n=0): g(n){}
  /*dodawanie krawedzi SKIEROWANEJ*/
  void AddEdge(int p,int k){Edge e; e.v=k; g[p].kr.PB(e);}
  vector<int> vis;
  Graf *nowy;
  void SccDfs(int v,int numer, bool sortuj){
    g[v].s=1; if (!sortuj) vis[v]=numer;
    FORE(it,g[v].kr) if (!g[it->v].s) SccDfs(it->v,numer,sortuj);
      else if (!sortuj && numer > vis[it->v])
        nowy->AddEdge(g[it->v].t,(vis[it->v]=numer));
    if (sortuj) vis.PB(v); else g[v].t=numer;
  }
  /*dla kazdego wierzcholka obliczamy numer silnie spojej skladowej,*/
  /*do ktorej on nalezy, numer ten jest w polu t,*/
  /*zwracamy graf prosty SCC, posortowany topologicznie*/
  Graf Scc(){
    Graf gt(SIZE(g)),res(SIZE(g)),*tab[]={this, &gt};
    gt.nowy=&res; gt.vis.resize(SIZE(g)); vis.clear();
    REP(i,SIZE(g)) gt.vis[i]=-1;
    REP(i,SIZE(g)) FORE(it,g[i].kr) gt.AddEdge(it->v,i);
    REP(i,2){
      FORE(it,tab[i]->g) it->s = 0;
      int l_sklad=0,v;
      FORD(j,SIZE(g)-1,0)
        if (!tab[i]->g[v=(i?vis[j]:j)].s) tab[i]->SccDfs(v,l_sklad++,1-i);
      if (i) res.g.resize(l_sklad);
    }
    REP(i,SIZE(g)) g[i].t=gt.g[i].t;
    return res;
  }
};


vector<int> graf[MAXN];
bitset<MAXN>* tc[MAXN];
vector<int> wym[MAXN];

int main(int argc, char **argv){
    Scanner out_contestant(argv[2], my_error);
    Scanner out_correct(argv[3]);
    Scanner in(argv[1]);
    
    char yesno[10], contestant_yesno[10];
    out_correct.readString(yesno, 10);
    out_correct.readEoln();

    out_contestant.readString(contestant_yesno, 10);
    out_contestant.skipWhitespaces();

    if(strcmp(yesno, "NO") == 0)
    {
        if(strcmp(contestant_yesno, "NO"))
            my_error("Expected 'NO'");
        out_contestant.readEof();
        puts("OK");
        return 0;
    }
    if(strcmp(contestant_yesno, "YES"))
        my_error("Solution not found");
    
    int n = in.readInt(1, MAXN);
    in.readSpace();
    int m = in.readInt(0, MAXM);
    in.readSpace();
    int k = in.readInt(0, MAXK);
    in.readEoln();

    Graf graf(n); 
    for(int i=0; i<m; i++)
    {
        int a = in.readInt(1, MAXN);
        in.readSpace();
        int b = in.readInt(1, MAXN);
        in.readEoln();

        int ac = out_contestant.readInt(1, MAXN);
        out_contestant.skipWhitespaces();
        int bc = out_contestant.readInt(1, MAXN);
        out_contestant.skipWhitespaces();
        if(ac != a)
            swap(a, b);
        if(ac != a || bc != b)
            my_error("Incorrect edge");
        ac --; bc --;
        graf.AddEdge(ac, bc);
    }
    out_contestant.readEof(); 
    

    Graf sccs = graf.Scc();

    for(int i=0; i<k; i++)
    {
        int a = in.readInt(1, MAXN);
        in.readSpace();
        int b = in.readInt(1, MAXN);
        in.readEoln();
        a --; b--;
        a = graf.g[a].t;
        b = graf.g[b].t;
        if(a != b)
            wym[a].PB(b);
    }
    in.readEof();

    for(int i=0; i<SIZE(sccs.g); i++)
    {
        tc[i] = new bitset<MAXN>();
        tc[i]->set(i);
    }

    for(int i=SIZE(sccs.g)-1; i>=0; i--)
    {
        FORE(it, sccs.g[i].kr)
            *tc[i] |= *tc[it->v];
        FORE(it, wym[i])
            if(!tc[i]->test(*it))
                my_error("Required path does not exist");
    }

    puts("OK");
    return 0;
}
